library algolib;

class UnionFind {
  List<int> _p, _rank, _setSize;
  int _numSets;

  UnionFind(int n) {
    _setSize = List<int>(n);
    _numSets = n;
    _rank = List<int>(n);
    _p = List<int>(n);
    for (int i = 0; i < n; i++) _p[i] = i;
  }

  // findin the parent of an element
  int findSet(int i) {
    return (_p[i] == i) ? i : (_p[i] = findSet(_p[i]));
  }

  // check if two element are in the same set
  bool isSameSet(int i, int j) {
    return findSet(i) == findSet(j);
  }

  // make two elements together
  void unionSet(int i, int j) {
    if (!isSameSet(i, j)) {
      _numSets--;
      int x = findSet(i), y = findSet(j);
      // rank is used to keep the tree short
      if (_rank[x] > _rank[y]) {
        _p[y] = x;
        _setSize[x] += _setSize[y];
      } else {
        _p[x] = y;
        _setSize[y] += _setSize[x];
        if (_rank[x] == _rank[y]) _rank[y]++;
      }
    }
  }

  // number of disjoint sets
  int numDisjointSets() {
    return _numSets;
  }

  // get the size of the set that contains a given element
  int sizeOfSet(int i) {
    return _setSize[findSet(i)];
  }
}
